﻿using Infragistics.Win;
using Infragistics.Win.UltraWinToolbars;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace _145647
{
    public partial class Form1 : Form
    {

        RibbonGroupUIElement ribbonGroup; 
        public Form1()
        {
            InitializeComponent();
        }


        

        private void ultraToolbarsManager1_MouseEnterElement(object sender, UIElementEventArgs e)
        {
            if (e.Element is RibbonGroupCaptionAreaUIElement)
            {
                ribbonGroup = (RibbonGroupUIElement)e.Element.Parent;
                e.Element.Control.MouseClick += Control_MouseClick;
            }
        }

        void Control_MouseClick(object sender, MouseEventArgs e)
        {
            if (ribbonGroup != null)
            {
                UIElement el = ribbonGroup.ChildElements.FirstOrDefault(tool => tool.GetContext(typeof(ToolBase)) != null);
                Point newCursorPosition = el.Rect.Location;
                newCursorPosition.Offset(el.Rect.Width / 2, el.Rect.Height / 2);
                newCursorPosition = ((Control)sender).PointToScreen(newCursorPosition);
                Cursor.Position = newCursorPosition;
            }
        }

        private void ultraToolbarsManager1_MouseLeaveElement(object sender, UIElementEventArgs e)
        {
            if (e.Element is RibbonGroupCaptionAreaUIElement)
                e.Element.Control.MouseClick -= Control_MouseClick;
        }


    }
}
